/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2002 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2001 - 2004 John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2004 Brad Jorsch (anomie@users.sourceforge.net),
                            funkyass (funkyass@spam.shaw.ca),
                            Joel Yliluoma (http://iki.fi/bisqwit/)
                            Kris Bleakley (codeviolation@hotmail.com),
                            Matthew Kendora,
                            Nach (n-a-c-h@users.sourceforge.net),
                            Peter Bortas (peter@bortas.org) and
                            zones (kasumitokoduck@yahoo.com)

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and Nach

  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2004 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman, neviksti (neviksti@hotmail.com),
                            Kris Bleakley, Andreas Naive

  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2004 zsKnight, pagefault (pagefault@zsnes.com) and
                            Kris Bleakley
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-DD1 C emulator code
  (c) Copyright 2003 Brad Jorsch with research by
                     Andreas Naive and John Weidman
 
  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  ST010 C++ emulator code
  (c) Copyright 2003 Feather, Kris Bleakley, John Weidman and Matthew Kendora

  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar, Gary Henderson and John Weidman


  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004 Marcus Comstedt (marcus@mc.pp.se) 

 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  SNES9X for Mac OS (c) Copyright John Stiles
  
  Snes9x for Mac OS X

  (c) Copyright 2001 - 2004 zones
  (c) Copyright 2002 - 2004 107
  (c) Copyright 2002        PB1400c
  (c) Copyright 2004        Alexander, Sander and Steven Seeger
*******************************************************************************/

#ifndef _mac_netplay_h_
#define _mac_netplay_h_

#define	WRITE_LONG(p, v) \
{ \
	*((p) + 0) = (uint8) ((v) >> 24); \
	*((p) + 1) = (uint8) ((v) >> 16); \
	*((p) + 2) = (uint8) ((v) >>  8); \
	*((p) + 3) = (uint8) ((v) >>  0); \
}

#define	WRITE_BYTE(p, v) \
{ \
	*(p) = (uint8) (v); \
}

#define READ_LONG(p) \
( \
	(((uint8) *((p) + 0)) << 24) | \
 	(((uint8) *((p) + 1)) << 16) | \
 	(((uint8) *((p) + 2)) <<  8) | \
 	(((uint8) *((p) + 3)) <<  0) \
)

#define READ_BYTE(p) \
( \
	(uint8) *(p) \
)

//#define SELF_TEST

#define	NP_SERVER_MAGIC	'S'
#define	NP_CLIENT_MAGIC	'C'
#define	NP_MAX_PLAYERS	5
#define	NP_MAX_CLIENTS	(NP_MAX_PLAYERS - 1)
#define NP_PORT			6096

#ifdef SELF_TEST
#define SOCK_NAME		"/tmp/s9xsocket"
#endif

enum
{
	kNPClientNameSent = 101,
	kNPClientROMInfoWaiting,
	kNPClientROMOpened,
	kNPClientSRAMWaiting,
	kNPClientSRAMLoaded,
	kNPClientPlayerWaiting,
	kNPClientPlayWaiting,
	kNPClientStartWait
};

enum
{
	kNPServerNameRequest = 201,
	kNPServerNameReceived,
	kNPServerROMInfoWillSend,
	kNPServerSRAMWillSend,
	kNPServerPlayerWillSend,
	kNPServerStart
};

int socket_read(int, unsigned char *, int);
int socket_write(int, unsigned char *, int);
void NPError(char *, int);
void NPNotification(char *, int);

#endif
